polybori::groebner::PairManagerWithStrategy< StrategyType > Class Template Reference

This class extends `PairManager` with a reference to a strategy. More...

`#include <PairManagerFacade.h>`

Inheritance diagram for polybori::groebner::PairManagerWithStrategy< StrategyType >:

## Public Member Functions

| PairManagerWithStrategy (const PairManager &mgr, StrategyType &strategy)
void | cleanTopByChainCriterion ()
void | introducePair (const Pair &pair)
Public Member Functions inherited from polybori::groebner::PairManager
| PairManager (const BoolePolyRing &ring)
void | appendHiddenGenerators (std::vector< Polynomial > &vec)
void | introducePair (const Pair &pair, bool isHFE)
Polynomial | nextSpoly (ReductionStrategy &gen)
bool | pairSetEmpty () const
template<class StrategyType >
void | cleanTopByChainCriterion (StrategyType &strat)

## Protected Member Functions

bool | isHFE () const
Protected Member Functions inherited from polybori::groebner::PairManager
Pair | popped ()
| `top()` and `pop()` at once More...

## Additional Inherited Members

Public Types inherited from polybori::groebner::PairManager
typedef std::priority_queue< Pair, std::vector< PairE >, PairECompare > | queue_type
Public Attributes inherited from polybori::groebner::PairManager
PairStatusSet | status
queue_type | queue

## Detailed Description

### template<class StrategyType>
class polybori::groebner::PairManagerWithStrategy< StrategyType >

This class extends `PairManager` with a reference to a strategy.

It defines variants of `PairManager::cleanTopByChainCriterion()` and `PairManager::introducePair(pair)` with explicit statement of the strategy.

Note
  This is done better in `PairManagerFacade` without storing an additional reference. For now - to keep the interface constant - we continue to allow code like `strat.pairs.cleanTopByChainCriterion()` and `strat.pairs.introducePair(pair)` .

## Constructor & Destructor Documentation

template<class StrategyType>

polybori::groebner::PairManagerWithStrategy< StrategyType >::PairManagerWithStrategy | ( | const PairManager & | mgr,
|  | StrategyType & | strategy
| ) |  |

inline

## Member Function Documentation

template<class StrategyType>

void polybori::groebner::PairManagerWithStrategy< StrategyType >::cleanTopByChainCriterion | ( |  | ) |

inline

Note
  Deprecated, use `PairManagerFacade::cleanTopByChainCriterion()` instead

Referenced by polybori::groebner::PairManagerWithStrategy< strategy_type >::cleanTopByChainCriterion().

template<class StrategyType>

void polybori::groebner::PairManagerWithStrategy< StrategyType >::introducePair | ( | const Pair & | pair | ) |

inline

Note
  Deprecated, use `PairManagerFacade::introducePair(pair)` instead

Referenced by polybori::groebner::GroebnerStrategy::addGeneratorDelayed(), polybori::groebner::GroebnerStrategy::addVariablePairs(), polybori::groebner::PairManagerWithStrategy< strategy_type >::introducePair(), and polybori::groebner::GroebnerStrategy::normalPairsWithLast().

template<class StrategyType>

bool polybori::groebner::PairManagerWithStrategy< StrategyType >::isHFE | ( |  | ) | const

inline protected

The documentation for this class was generated from the following file:

- PairManagerFacade.h